[LeetCode]Reconstruct Itinerary

来源:互联网 发布:韦德生涯场均数据 编辑:程序博客网 时间:2024/05/29 15:26

Given a list of airline tickets represented by pairs of departure and arrival airports [from, to], reconstruct the itinerary in order. All of the tickets belong to a man who departs from JFK. Thus, the itinerary must begin with JFK.

Note:

  1. If there are multiple valid itineraries, you should return the itinerary that has the smallest lexical order when read as a single string. For example, the itinerary ["JFK", "LGA"] has a smaller lexical order than ["JFK", "LGB"].
  2. All airports are represented by three capital letters (IATA code).
  3. You may assume all tickets form at least one valid itinerary.

Example 1:
tickets = [["MUC", "LHR"], ["JFK", "MUC"], ["SFO", "SJC"], ["LHR", "SFO"]]
Return ["JFK", "MUC", "LHR", "SFO", "SJC"].

Example 2:
tickets = [["JFK","SFO"],["JFK","ATL"],["SFO","ATL"],["ATL","JFK"],["ATL","SFO"]]
Return ["JFK","ATL","JFK","SFO","ATL","SFO"].
Another possible reconstruction is ["JFK","SFO","ATL","JFK","ATL","SFO"]. But it is larger in lexical order.


求欧拉路径,图论中真的有太多经典的算法,有时间一点要好好总结一下,每一个都玩一遍:

public class Solution {    public List<String> findItinerary(String[][] tickets) {  HashMap<String,PriorityQueue<String>> graph=new HashMap<String, PriorityQueue<String>>();  for(int i=0;i<tickets.length;i++){  if(!graph.containsKey(tickets[i][0])){   graph.put(tickets[i][0],new PriorityQueue<String>());  }  graph.get(tickets[i][0]).add(tickets[i][1]);  }  dfs("JFK",graph);  return res; } LinkedList<String> res=new LinkedList<String>(); public void dfs(String s,HashMap<String,PriorityQueue<String>> graph){//由欧拉回路性质可知(每个定点的入度和出度相等),因为存在,所以一定能走通  while(graph.containsKey(s)&&graph.get(s).size()>0){  dfs(graph.get(s).poll(),graph);  }  res.addFirst(s); }}


原创粉丝点击